# coding=UTF-8
"""
It sounds like a melody
"""
from __future__ import print_function, absolute_import, division
import six
from sai.basic import SQL
from collections import defaultdict
import time
from circle.metrics.utils import CounterHelper

CNTRS = {
    'started': CounterHelper(),
    'ended': CounterHelper()
}


def get_alarms():
    with SQL.cursor('catalog', 'smok4_sars') as cur:

        cur.execute('SELECT start_on, token FROM event WHERE start_on > %s', (int(time.time() - 24*60*60),))
        started = cur.fetchall()

        cur.execute('SELECT end_on, token FROM event WHERE end_on > %s', (int(time.time() - 24*60*60),))
        stopped = cur.fetchall()

    by_tokens = defaultdict(lambda: defaultdict(lambda: 0)) # by token, action

    for action, lst in zip(['started', 'ended'], [started, stopped]):
        for ts, token in lst:
            by_tokens[token][action] += 1
            CNTRS[action].feed(ts)

    st_v = len(started[0])

    for action, cntr in CNTRS.iteritems():
        yield 'smok4_alarms_total{action="%s"} %s' % (action, cntr.value())

    for token, stat in by_tokens.iteritems():
        for action, v in stat.iteritems():
            yield 'smok4_alarms_rollup{rollup="24h", token="%s", action="%s"} %s' % (token, action, v)


