# coding=UTF-8
"""
Serves HTTP requests
"""
from __future__ import print_function, absolute_import, division
import six
import logging
import threading
import SimpleHTTPServer
import SocketServer
from .metrics import setup_metrics

logger = logging.getLogger(__name__)


class CircleRequestHandler(SimpleHTTPServer.SimpleHTTPRequestHandler):
    """
    WARNING!
    SimpleHTTPServer.SimpleHTTPRequestHandler is an
    
    OLD
    
    STYLE
    
    OBJECT
    
    
    exercise due care!
    """
    def do_GET(self):
        if 'favicon.ico' in self.path:
            self.send_error(404)
            return

        self.send_response(200)
        self.send_header('Content-Type', 'text/plain')
        self.send_header('Content-Encoding', 'utf8')
        self.end_headers()

        for metric in self.server.metrics:

            lines_for_this_metric = list(metric())
            response = (u'\n'.join(lines_for_this_metric)).encode('utf8')
            self.wfile.write(response)
            print(response)
            self.wfile.write(b'\n')


def start_serving_thread(bindifc):
    """
    Start a daemonic serving thread and return.
    :param bindifc: tuple of (addr, port) to listen on
    """

    class _InnerServe(threading.Thread):
        def run(self):
            httpd = SocketServer.TCPServer(bindifc, CircleRequestHandler)
            httpd.metrics = setup_metrics()
            httpd.serve_forever()

    t = _InnerServe()
    t.daemon = True
    t.start()
